'FFSubmenu=Bilderlisten
'FFName=Listengenerator
' ********************************************************************
' Listengenerator.vbs (Skript fr FixFoto)
' Funktion:	Fr ausgewhlte Bilder Listen abhngig vom Aufnahmedatum erzeugen.
'
' Copyright Harald Maeckler, Dsseldorf 2014 - 2016
'
' ********************************************************************
'
' Version 1.01 vom 29.03.2016	- Skript-URL gem Forenberarbeitung gendert
' Version 1.00 vom 09.10.2014	- Betaversion
' ********************************************************************

Option Explicit

'Skriptname
Dim SkriptName
const Skript = "Listengenerator"
const RegSchluessel = "FF_Listengenerator"

'Updatekonstanten und Variable
const SkriptVersion = "1.01"
const SkriptURL = "http://www.ffsf.de/resources/listengenerator.157/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim TempFile,SkriptKill	 : SkriptKill = false

'Allgemeine Deklarationen
Dim Anzeige,Antwort,Abbruch : Abbruch = false
Const ForReading = 1, ForWriting = 2, ForAppending = 8

'Skriptspezifische Deklarationen
const Auswahl = 1	'Auswahl markierte Bilder in der Comp.-Ansicht
Dim flag_jd,flag_DB,DatumVon,DatumBis,diffDat
Dim flag_VirtL,flag_VerzL,Verzeichnis,flag_nurVerz
Dim BildAuswahl,BildArray,imgAnz,bNr,flag_VerzOD

'------------------------------------------------------------------------
call Main
'------------------------------------------------------------------------
Sub Main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if Err.Number > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog Listengenerator **
FF_AddDialog "Listengenerator",125,177
FF_AddControl "Listengenerator","jedes Datum","GROUP",5,5,115,49
FF_AddControl "Listengenerator","Datumsbereich","GROUP",5,16,115,38
FF_AddControl "Listengenerator","Listenvorgaben","GROUP",5,57,115,77
FF_AddControl "Listengenerator","flag_jD","BOOL",80,4,8,8
FF_SetControlStyle "Listengenerator","flag_jD",16384
FF_AddControl "Listengenerator","flag_DB","BOOL",80,15,8,8
FF_SetControlStyle "Listengenerator","flag_DB",16384
FF_AddControl "Listengenerator","&delete","BUTTON",0,0,1,1
FF_AddControl "Listengenerator","vom","STATIC",13,26,14,10
FF_AddControl "Listengenerator","DatumVon","SLEDIT",26,26,44,10
FF_SetControlStyle "Listengenerator","DatumVon",2049
FF_AddControl "Listengenerator","<<<","BUTTON",74,26,18,10
FF_AddControl "Listengenerator","Heute","BUTTON",95,26,20,10
FF_AddControl "Listengenerator","bis","STATIC",13,38,14,10
FF_AddControl "Listengenerator","DatumBis","SLEDIT",26,38,44,10
FF_SetControlStyle "Listengenerator","DatumBis",2049
FF_AddControl "Listengenerator","|<<<","BUTTON",74,38,18,10
FF_AddControl "Listengenerator","|Heute","BUTTON",95,38,20,10
FF_AddControl "Listengenerator","flag_VirtL","BOOL",13,68,8,8
FF_SetControlStyle "Listengenerator","flag_VirtL",16384
FF_AddControl "Listengenerator","virtuelle Liste","STATIC",26,67,35,10
FF_AddControl "Listengenerator","flag_VerzL","BOOL",13,80,8,8
FF_SetControlStyle "Listengenerator","flag_VerzL",16384
FF_AddControl "Listengenerator","Verzeichnisliste","STATIC",26,79,35,10
FF_AddControl "Listengenerator","Verzeichnis","SLEDIT",26,91,66,10
FF_SetControlStyle "Listengenerator","Verzeichnis",2048
FF_AddControl "Listengenerator","...","BUTTON",95,91,20,10
FF_AddControl "Listengenerator","Vorgang abbrechen mit","STATIC",10,146,57,10
FF_AddControl "Listengenerator","Escape","BUTTON",68,147,26,8
FF_AddControl "Listengenerator","- Taste","STATIC",95,146,20,10
FF_AddControl "Listengenerator","Fortschritt","PROGRESS",5,138,115,4
FF_AddControl "Listengenerator","?","BUTTON",7,161,11,11
FF_AddControl "Listengenerator","|","STATIC",21,161,20,11
FF_SetControlStyle "Listengenerator","|",1
FF_AddControl "Listengenerator","Update","BUTTON",43,161,22,11
FF_AddControl "Listengenerator","Ende","BUTTON",70,161,22,11
FF_AddControl "Listengenerator","Start","BUTTON",96,161,22,11
FF_AddControl "Listengenerator","flag_nurVerz","BOOL",26,106,8,8
FF_AddControl "Listengenerator","nur Verzeichnisse, keine Listen","STATIC",38,105,77,10
FF_AddControl "Listengenerator","-","STATIC",9,117,108,4
FF_SetControlStyle "Listengenerator","-",16
FF_AddControl "Listengenerator","flag_VerzOD","BOOL",13,122,8,8
FF_AddControl "Listengenerator","Liste fr Bilder 'ohne Datum' anlegen","STATIC",26,120,91,11
'** End Dialog Listengenerator **

call RegistryLesen

'Tooltips
FF_SetControlTooltip "Listengenerator","<<<", "Datumseingabe ..."
FF_SetControlTooltip "Listengenerator","Heute", "Heutiges Datum wird eingegeben."
FF_SetControlTooltip "Listengenerator","|<<<", "Datumseingabe ..."
FF_SetControlTooltip "Listengenerator","|Heute", "Heutiges Datum wird eingegeben."
FF_SetControlTooltip "Listengenerator","...", "" &_
					"bergeordnetes Verzeichnis der" & vbNewLine &_
					"Verzeichnisliste auswhlen ..."
FF_SetControlTooltip "Listengenerator","Escape", "" &_
					"Abarbeitung kann durch Bettigung der" & vbNewLine &_
					"ESCAPE-Taste abgebrochen werden."
FF_SetControlTooltip "Listengenerator","?", "" &_
					"Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & _
					"vorausgesetzt es ist ein PDF-Reader installiert."
FF_SetControlTooltip "Listengenerator","Update", "" &_
					"Prfung ob eine neue Version vorliegt."
FF_SetControlTooltip "Listengenerator","Ende", "" &_
					"Das Skript wird beendet."
FF_SetControlTooltip "Listengenerator","Start", "" &_
					"Die Listenerzeugung wird gestartet."

if Version_OK("3.40.52") then FF_SetTooltipDelay 3000
FF_ActivateControl "Listengenerator","&delete"
FF_SetDialogTimer "Listengenerator", 100

do
	Abbruch = false
	
	'Tooltips
	FF_SetControlTooltip "Listengenerator","Verzeichnis", "" &_
						"bergeordnetes Verzeichnis der Verzeichnisliste: " &_
						vbNewline & Verzeichnis
	
	Select Case FF_ShowDialog ("Listengenerator")
	
	Case "TIMER"
		FF_SetControl "Listengenerator" ,"|","V " & Skriptversion
		FF_SetDialogTimer "Listengenerator", 0
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "flag_jD"
		FF_SetControl "Listengenerator","flag_jD",1
		FF_SetControl "Listengenerator","flag_DB",0
	Case "flag_DB"
		FF_SetControl "Listengenerator","flag_jD",0
		FF_SetControl "Listengenerator","flag_DB",1
	Case "<<<"
		DatumVon = InputBox("Datumseingabe" & vbNewLine & "(Tag.Monat.Jahr)","Datum vom ...")
		if isDate(DatumVon) then
			DatumVon = cdate(DatumVon)
			FF_SetControl "Listengenerator","DatumVon",DatumVon
		else
			msgbox "Der eingegebene Wert ist kein gltiges Datum.",vbInformation,"Hinweis"
		end if
	Case "Heute"
		DatumVon = date
		FF_SetControl "Listengenerator","DatumVon",DatumVon
	Case "|<<<"
		DatumBis = InputBox("Datumseingabe" & vbNewLine & "(Tag.Monat.Jahr)","Datum bis ...")
		if isDate(DatumBis) then
			DatumBis = cdate(DatumBis)
			FF_SetControl "Listengenerator","DatumBis",DatumBis
		else
			msgbox "Der eingegebene Wert ist kein gltiges Datum.",vbInformation,"Hinweis"
		end if
	Case "|Heute"
		DatumBis = date
		FF_SetControl "Listengenerator","DatumBis",DatumBis
	Case "flag_VirtL"
		FF_SetControl "Listengenerator","flag_VirtL",1
		FF_SetControl "Listengenerator","flag_VerzL",0
	Case "flag_VerzL"
		FF_SetControl "Listengenerator","flag_VirtL",0
		FF_SetControl "Listengenerator","flag_VerzL",1
	Case "..."
		Dim Pfad
		FF_SetCurrentPath Verzeichnis
		Pfad = FF_EnterPath(false,"Wahl des bergeordneten Verzeichnis")
		if len(Pfad) > 2 then
			Verzeichnis = Pfad & "\"
			FF_SetControl "Listengenerator","Verzeichnis",Verzeichnis
		end if
	Case "?"
		'FF_SetControl "Listengenerator","Fortschritt",65	'############## nur fr Screenshot
		Anzeige = chr(34) & FF_GetScriptPath & "\MeckiScript\Listengenerator\Listengenerator.pdf" & chr(34)
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?).",vbExclamation,"Hinweis"
			err.clear
		end if
		on error GoTo 0
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Ende","CANCEL"
		Abbruch = true
		exit do
	Case "Start"
		call WerteAuslesen
		call Kontrolle
		if not Abbruch then
			call Schleife
		end if
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Listengenerator")

if SkriptKill then	'ggf. Skript komplett entfernen
	call KillSkript
end if

End Sub
'------------------------------------------------------------------------
Sub Schleife
'Abarbeitung aller ausgewhlten Bilder
Dim BildDatum,DatumVon_alt,diff

BildAuswahl = FF_GetSelection(Auswahl)
if len(BildAuswahl) = 0 then
	msgbox "Es sind keine Bilder ausgewhlt!",vbExclamation,"Abbruch"
	exit sub : Abbruch = true
end if

if flag_DB = 1 then
	diffDat = DateDiff("d",DatumVon,DatumBis)
	if diffDat < 0 then
		DatumVon_alt = DatumVon
		DatumVon = DatumBis
		DatumBis = DatumVon_alt
	end if
	diffDat = abs(diffDat)
end if

BildArray = split(BildAuswahl, vbNewLine)
imgAnz = ubound(BildArray) + 1

for bNr = 0 to imgAnz -1
	FF_LoadImage(BildArray(bNr))
	BildDatum = FF_GetExifTag("DateTime")
	if instr(BildDatum,":") > 0 then
		BildDatum = left(BildDatum,10)
		Bilddatum = cdate(replace(Bilddatum,":","."))
		
		if flag_DB = 1 then
			diff = DateDiff("d",DatumVon,Bilddatum)
			if diff >= 0 and diff <= diffDat then call Eintrag (Bilddatum)
		else
			call Eintrag (Bilddatum)
		end if
	else
		if flag_VerzOD = 1 then call Eintrag ("ohne Datum")
	end if
	
	if FF_CheckKey() = 8 then 	'8 = Backspace
		Antwort = msgbox("Von " & imgAnz & " Dateien wurden bisher " & bNr +1 & _
						 " Bilder abgearbeitet." & vbNewLine & vbNewLine & _
						 "Soll das Skript abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then exit sub
	end if
	
	FF_SetControl "Listengenerator","Fortschritt",(bNr +1)/imgAnz*100
next

if flag_VerzL = 1 then FF_SetImagePath Verzeichnis	'Verzeichnisliste aktualisieren
msgbox "Es wurden " & imgAnz & " Bilder abgearbeitet." & vbNewLine & vbNewline &_
		"Das Skript kann jetzt beendet oder" & vbNewLine &_
		"nach Auswahl anderer Bilder erneut gestartet werden.",vbInformation,"Schlussmeldung"

End Sub
'------------------------------------------------------------------------
Sub Eintrag (Datum)
'ggf. Erzeugung einer Bilderliste und Bildeintrag
Dim Listen,n,Pfad
Dim Zulassung : Zulassung = true

if flag_VirtL then
	Listen = vbNewLine & FF_IListGetLists & vbNewLine		'alle virtullen Bilderlisten
	if instr(Listen,vbNewLine & Datum & vbNewLine) = 0 then	'ggf. neue Liste erstellen
		FF_IListCreate Datum
	end if
	
	if FF_IListGetCount(Datum) > 0 then
		for n = 0 to FF_IListGetCount(Datum) -1				'prfen ob Bild bereits vorhanden
			if FF_IListGetFile(Datum,n) = BildArray(bNr) then
				Zulassung = false : exit for
			end if
		next
	end if
	if Zulassung then FF_IListInsertFile Datum,BildArray(bNr),-1
	FF_IListUpdate Datum
else
	Pfad = Verzeichnis & Datum & "\"
	if flag_nurVerz = 1 then
		if not objFS.FolderExists(Pfad) then
			objFs.CreateFolder(Pfad)
		end if
		objFS.CopyFile BildArray(bNr),Pfad & objFS.GetFileName(BildArray(bNr))
	else
		Listen = vbNewLine & FF_IPathGetLists & vbNewLine		'alle Verzeichnislisten
		if instr(Listen,vbNewLine & Pfad & vbNewLine) = 0 then	'ggf. neues Verzeichnis und Liste erstellen
			if not objFS.FolderExists(Pfad) then
				objFs.CreateFolder(Pfad)
			end if
			FF_IPathCreate Pfad,Pfad
		end if
		objFS.CopyFile BildArray(bNr),Pfad & objFS.GetFileName(BildArray(bNr))
		FF_IListUpdate Pfad
	end if
end if

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Standard-Routinen
'************************************************************************
Sub WerteAuslesen

flag_jd = FF_GetControl("Listengenerator","flag_jD")
flag_DB = FF_GetControl("Listengenerator","flag_DB")
DatumVon = FF_GetControl("Listengenerator","DatumVon")
DatumBis = FF_GetControl("Listengenerator","DatumBis")
flag_VirtL = FF_GetControl("Listengenerator","flag_VirtL")
flag_VerzL = FF_GetControl("Listengenerator","flag_VerzL")
Verzeichnis = FF_GetControl("Listengenerator","Verzeichnis")
flag_nurVerz = FF_GetControl("Listengenerator","flag_nurVerz")
flag_VerzOD = FF_GetControl("Listengenerator","flag_VerzOD")

End Sub
'------------------------------------------------------------------------
Sub Kontrolle

if not isDate(DatumVon) then
	msgbox  "Das 'vom'-Datum ist kein" & vbNewLine & _
			"gltiges Datum!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

if not isDate(DatumBis) then
	msgbox  "Das 'bis'-Datum ist kein" & vbNewLine & _
			"gltiges Datum!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

if flag_VerzL = 1 and not objFS.FolderExists(Verzeichnis) then
	msgbox  "Das Verzeichnis" & vbNewLine & "  " & Verzeichnis & vbNewLine &_
			"existiert nicht!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

'Datum-Vorgaben
flag_jD = FF_GetProfile (RegSchluessel,"flag_jD")
if len(flag_jD) = 0 then flag_jD = 1

if flag_jD = 1 then
	flag_DB = 0
else
	flag_DB = 1
end if

DatumVon = FF_GetProfile (RegSchluessel,"DatumVon")
if len(DatumVon) = 0 then DatumVon = Date

DatumBis = FF_GetProfile (RegSchluessel,"DatumBis")
if len(DatumBis) = 0 then DatumBis = Date

'Listenvorgaben
flag_VirtL =  FF_GetProfile (RegSchluessel,"flag_VirtL")
if len(flag_VirtL) = 0 then flag_VirtL = 1

if flag_VirtL = 1 then
	flag_VerzL = 0
else
	flag_VerzL = 1
end if

Verzeichnis =  FF_GetProfile (RegSchluessel,"Verzeichnis")
if len(Verzeichnis) = 0 then Verzeichnis = "C:\"

flag_nurVerz =  FF_GetProfile (RegSchluessel,"flag_nurVerz")
if len(flag_nurVerz) = 0 then flag_nurVerz = 0

flag_VerzOD =  FF_GetProfile (RegSchluessel,"flag_VerzOD")
if len(flag_VerzOD) = 0 then flag_VerzOD = 1

'### Werte eintragen

'Datum-Vorgaben
FF_SetControl "Listengenerator","flag_jD",flag_jD
FF_SetControl "Listengenerator","flag_DB",flag_DB
FF_SetControl "Listengenerator","DatumVon",DatumVon
FF_SetControl "Listengenerator","DatumBis",DatumBis
'Listenvorgaben
FF_SetControl "Listengenerator","flag_VirtL",flag_VirtL
FF_SetControl "Listengenerator","flag_VerzL",flag_VerzL
FF_SetControl "Listengenerator","Verzeichnis",Verzeichnis
FF_SetControl "Listengenerator","flag_nurVerz",flag_nurVerz
FF_SetControl "Listengenerator","flag_VerzOD",flag_VerzOD

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call WerteAuslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"flag_jD",flag_jD
FF_WriteProfile RegSchluessel,"flag_DB",flag_DB
FF_WriteProfile RegSchluessel,"DatumVon",DatumVon
FF_WriteProfile RegSchluessel,"DatumBis",DatumBis
FF_WriteProfile RegSchluessel,"flag_VirtL",flag_VirtL
FF_WriteProfile RegSchluessel,"flag_VerzL",flag_VerzL
FF_WriteProfile RegSchluessel,"Verzeichnis",Verzeichnis
FF_WriteProfile RegSchluessel,"flag_nurVerz",flag_nurVerz
FF_WriteProfile RegSchluessel,"flag_VerzOD",flag_VerzOD

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Delete-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & Skript & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & Skript & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & Skript & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### beigepackten Ordner lschen
TempFile = FF_GetScriptPath & "\MeckiScript\" & Skript
if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Allgemein
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Function Farbreferenz (RGB_Wert)
'RGB-Wert ("000 000 000" bis "255 255 255") zu Farbreferenz (0 - 16777215)
Dim C_Array
	C_Array = split(RGB_Wert," ")
	Farbreferenz = C_Array(0) + C_Array(1) * (2^8) + C_Array(2) * (2^16)
End Function
'--------------------------------------------------------------
